package tp2;

import java.awt.Dimension;
import java.awt.Graphics;
import java.util.logging.Level;
import java.util.logging.Logger;
import javax.swing.JButton;
import javax.swing.JPanel;

public class PanelDibujo extends JPanel implements Runnable {

    private int ancho = 1000;

    private int alto = 1000;

    private int n = 0;

    private Dibujo objeto;
    


    public PanelDibujo() {

        setPreferredSize(new Dimension(ancho, alto));
        setLayout(null);

        
    }

    public void resolverVonKoch(int nro, int profundidad) {

        objeto = new Vonkoch(profundidad);
        this.repaint();
    }

    public void paintComponent(Graphics gc) {
        super.paintComponent(gc);
        if (objeto != null) {
            objeto.dibujar(gc);
        }

        empezar();
    }

    private void empezar() {

        this.resolverVonKoch(Fractal.VONKOCH, n);

    }

    public int getN() {
        return n;
    }

    public void setN(int n) {
        this.n = n;
    }
    
    

    @Override
    public void run() {
        while (n < 8) {

            empezar();

            try {
                this.repaint();
                Thread.sleep(2000);

            } catch (InterruptedException ex) {
                Logger.getLogger(PanelDibujo.class.getName()).log(Level.SEVERE, null, ex);
            }

            n++;

        }
    }
}
